#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>

#define MAX_SIZE 21
#define MAX_ANS_SIZE 10000

using namespace std;

typedef unsigned long int ll;

ll m, n;

ll m_divisors[MAX_SIZE];
ll m_divisors_c[MAX_SIZE];
ll ans[MAX_ANS_SIZE];

int ans_c = 0;

ll pow(ll x, ll y){
    if(y == 0){
        return 1;
    }
    if(y == 1){
        return x;
    }
    ll z = x;
    for(ll i = 1; i < y; i++){
        x *= z;
    }
    return x;
}

void variants(ll mult, int min_var, int max_var){
    for(int i = min_var; i < max_var; i++){
        ll mul = 1;
        for(int j = 0; j < max_var; j++){
            if(j != i)
                mul *= (m_divisors_c[j] + 1);
        }
        m_divisors_c[i]++;
        if(mul + mult == n){
            ll sum = 1;
            for(int j = 0; j < max_var; j++){
                sum *= pow(m_divisors[j], m_divisors_c[j]);
            }
            ans[ans_c] = sum;
            ans_c++;
        }else if(mul + mult < n){
            variants(mul + mult, i, max_var);
        }
        m_divisors_c[i]--;
    }
}

int toDivisors(long long num){
    fill(m_divisors_c, m_divisors_c + MAX_SIZE, 0);
    int i = 2;
    int c = 0;
    while(num != 1){
        if(num % i == 0){
            if(m_divisors_c[c] == 0)
                m_divisors[c] = i;
            m_divisors_c[c]++;
            num /= i;
            continue;
        }
        if(m_divisors_c[c] != 0){
            c++;
        }
        i++;
    }
    return c;
}

int main()
{
    freopen("divisors.in", "r", stdin);
    freopen("divisors.out", "w", stdout);
    cin >> m >> n;
    int maxim = toDivisors(m);
    ll multiplied = 1;
    for(int i = 0; i <= maxim; i++){
        multiplied *= (m_divisors_c[i] + 1);
    }
    variants(multiplied, 0, maxim + 1);
    sort(ans, ans + ans_c);
    if(ans_c == 0){
        cout << '0';
    }else{
        cout << ans[0];
    }
    for(int i = 1; i < ans_c; i++){
        cout << ' ' << ans[i];
    }
    ll a1 = 5;
    ll a2 = 3;
    return 0;
}
