/* GCC */
#include<iostream>
#include<vector>
#include<cstdio>
#define ll unsigned long long

using namespace std;

const int N = 1e4 + 1;

int n, k;

vector<int> d[N];
ll dp[N];

void init(int n){
    for(int i = 1; i <= n; ++i)
        for(int j = 2*i; j <= n; j += i)
            d[j].push_back(i);
    for(int i = 0; i < d[n].size(); ++i)
        dp[d[n][i]] = -1;
    dp[n] = -1;
}

ll binpow(ll a, ll s){
    ll ans = 1;
    while(s){
        if(s&1)
            ans *= a;
        a *= a;
        s >>= 1;
    }
    return ans;
}

ll f(int n){
    if(dp[n] != -1)
        return dp[n];
    ll sum = binpow(k, n);
    for(int i = 0; i < d[n].size(); ++i)
        sum -= f(d[n][i]);
    return dp[n] = sum;
}

ll solve(int n){
    init(n);
    ll ans = f(n) / n;
    for(int i = 0; i < d[n].size(); ++i)
        ans += f(d[n][i]) / d[n][i];
    return ans;
}

int main(){
    freopen("marks.in", "r", stdin);
    freopen("marks.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    cin >> n >> k;
    cout << solve(n) << endl;
}
