/* GCC */

#include <iomanip>
#include <fstream>
#include <cmath>
#include <vector>
#include <map>
#include <algorithm>

uint_fast32_t k = 0;
uint_fast32_t n = 0;
uint_fast32_t* ans;

std::vector<uint_fast32_t*> results;

inline void nextPossibleAnswer()
{
    for(uint_fast32_t i = 0; i < n; i++)
    {
        ans[i]++;
        if(ans[i] == k)
        {
            ans[i] = 0;
            continue;
        }
        return;
    }
}

inline void checkAnswer(uint_fast32_t* answ)
{
    for(uint_fast32_t i = 0; i < n; i++)
    {
        for(uint_fast32_t j = 0; j < results.size(); j++)
        {
            bool correct = false;

            for(uint_fast32_t f = 0; f < n; f++)
            {
                if(results[j][f] != answ[(i + f) % n])
                {
                    correct = true;
                    break;
                }
            }

            if(!correct)
            {
                delete[] answ;
                return;
            }
        }
    }
    results.push_back(answ);
}

int main()
{
    std::ifstream in("marks.in");
    std::ofstream out("marks.out");

    in >> n >> k;

    ans = new uint_fast32_t[n]();
    for(int i = 0; i < n; i++)
        ans[i] = 0;

    results.empty();

    for(uint_fast32_t i = 0; i < pow(k, n); i++)
    {
        nextPossibleAnswer();
        uint_fast32_t* temp = new uint_fast32_t[n];
        for(uint_fast32_t i = 0; i < n; i++) temp[i] = ans[i];
        checkAnswer(temp);
    }

    out << std::fixed << results.size();
    for(int i = 0; i < results.size(); i++)
        delete[] results[i];

    return 0;
}

