/* GCC */
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

vector<long long> find_simple_divisors(long long m)
{
    vector<long long> divisors_simple;
    long long a = 2;
    while(m != 1)
    {
        if(m % a == 0)
        {
            m /= a;
            divisors_simple.push_back(a);
            a = 2;
        }
        else ++a;
    }
    return divisors_simple;
}

int check_divisors(int number)
{
    int answer = 2;
    for(int i = 2; i < number; i++)
    {
        if(number % i == 0)
        {
            answer++;
        }
    }
    return answer;
}

bool compare_divisors(int m, vector<long long> divs)
{
    long long a = 2;
    while(m != 1)
    {
        if(m % a == 0)
        {
            m /= a;
            int high_bound = divs.size()-1;
            int low_bound = 0;
            int middle = 0;
            bool found = false;
            while(true)
            {
                middle = (high_bound + low_bound) / 2;
                if(a == divs[middle])
                {
                   found = true;
                   break;
                }
                else if (a < divs[middle])
                {
                    if(high_bound <= low_bound)
                    break;
                    high_bound = middle - 1;

                }
                else
                {
                    if(high_bound <= low_bound)
                    break;
                    low_bound = middle + 1;
                }
            }
            if(!found)
                return false;
            a = 2;
        }
        else ++a;
    }
    return true;
}

int main()
{
    ifstream file_r;
    file_r.open("divisors.in");
    long long m = 0;
    int n = 0;
    file_r >> m >> n;
    file_r.close();

    vector<long long> m_divisors = find_simple_divisors(m);

    ofstream file_w;
    file_w.open("divisors.out");
    bool b = false;
    bool a = false;
    for(int i = m+m; i < 12000; i+=m)
    {
        if(m % 2 != 0)
            i+=m;

        if(check_divisors(i) == n && compare_divisors(i, m_divisors))
        {
            if(!a)
                file_w << i;
            else
                file_w << " " << i;
            a=true;
            b=true;
        }
    }
    if(!b)
        file_w << 0;
    file_w << endl;
    file_w.close();
    return 0;
}
