/* GCC */
#include <iostream>
#include <fstream>
#include <cmath>

using namespace std;

int getChunksAmount(double chunkSize, double amount) {
    return ceil(amount / chunkSize);
}


long long getMinimalTime(int banknotesAmount, int simpleCheckTime, int badCheckTime, short triesAmount) {

    if (banknotesAmount < 2) return 0;

    long long minimalTime;
    short currentChunkSize = 1, maxChunkSize = min(triesAmount + 1, banknotesAmount);

    minimalTime = (getChunksAmount(currentChunkSize, banknotesAmount) - 2) * simpleCheckTime + badCheckTime + getMinimalTime(currentChunkSize, simpleCheckTime, badCheckTime, triesAmount - 1);

    for (currentChunkSize = 2; currentChunkSize < maxChunkSize; currentChunkSize++) {
        minimalTime = min(minimalTime, (getChunksAmount(currentChunkSize, banknotesAmount) - 2) * simpleCheckTime + badCheckTime + getMinimalTime(currentChunkSize, simpleCheckTime, badCheckTime, triesAmount - 1));
    }

    return minimalTime;
}


int main() {
    ifstream input ("cash.in");
    ofstream output ("cash.out");

    int banknotesAmount, simpleCheckTime, badCheckTime;
    short triesAmount;

    input >> banknotesAmount >> simpleCheckTime >> badCheckTime >> triesAmount;


    output << getMinimalTime(banknotesAmount, simpleCheckTime, badCheckTime, triesAmount) << endl;


    return 0;
}
